/*
 *  E-FolioB
 *  Auxiliar.cpp
 *
 *     Created on: 24/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */


#include "Auxiliar.h"

namespace std{

//  Nesta fase do trabalho quis testar vrias opes de validao da as diferentes aproximaes nas validadaes
// dos inputs do teclado. Aqui aprendi e apliquei com sucesso, operaes desde manipulao de flags na cin at a verificaes em strings.


// Funo que recebe e verifica um nmero inteiro do teclado
int getIntFromUser(){
	int valor;
	cin>>valor;																				// Recebe valor do input cin do teclado

	while(1){																				// Ciclo infinito at um break
																							// Deteta erro no input e limpa buffer de cin
		if(cin.fail()){																			// Caso a flag fail do cin esteja ativa ( valor inserido no  um int)
			cin.clear();																		// Limpa todas as flags de cin
			cin.ignore(numeric_limits<streamsize>::max(),'\n');									// e ignora a informao do buffer at ao \n ( a incluso de limits no header  para esta linha )
			cout<<"O valor que inseriu  invlido ( No numrico )"<<endl;						// Informa o utilizador de que no inseriu um inteiro
			cout << "Por favor insira um valor vlido" << endl;									// e pede para voltar a inserir
			cin>>valor;																			// L novo valor do input
				}
				if(!cin.fail())																	// Caso a flag fail de cin seja zero, o valor j  um inteiro
					break;																		// Sai do ciclo
			}
	return valor;																				// devolve o inteiro valor
}

// Funo que recebe e verifica um nmero real (float) do teclado
float getFloatFromUser(){
	float valor;
	string dados;
	cin >> dados;																			// Recebe uma string do input

	while(1){																				// Ciclo infinito at um break
	   if( dados.find_first_not_of("1234567890.-") != string::npos ) {						// No caso da string dados no conter apenas os digitos numricos o ponto e o sinal negativo
		    cout << "ATENO: Valor invlido, por favor insira um nmero Real ( digitos aceitveis '1234567890 . -' ): " << dados << endl;	// Informa o utilizador e pede para voltar a inserir
		  } else {
		    valor = stof( dados );															// Seno inicializa valor com a string dados convertida para float
		    break;																			// Sai do ciclo
		  }
	}
	return valor;																			// Retorna valor
}


// Funo que converte um array char* para string
string charArrayToString( char* a ){
	string s="";															// String que vai receber a converso
	int size = strlen (a) ;													// Comprimento do array
	for (int i=0; i < size ; i++)											// Para cada caracter
		s=s+a[i];															// soma  string
	return s;																// retorna string
}


}
