/*
 *  E-FolioB
 *  Menu.cpp
 *
 *     Created on: 17/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#include "Cmenu.h"


namespace std {

// Construtor vazio
Cmenu::Cmenu(){
}

// Construtor que preenche para cada ficheiro, os dados de um curso, nome de ficheiro do curso, cdigo do curso e nome do curso
Cmenu::Cmenu( string nomeF ){
	string nome;
	ifstream ficheiro;
	string linha,dados;
	setNomeFicheiro(nomeF);											// inicializa o nome do ficheiro do curso para nomeficheiro
	ficheiro.open(nomeF, ios::in);									// Abre o ficheiro nomeF
		if (ficheiro.is_open()){									// Caso esteja aberto
			while ( getline( ficheiro,linha) ){						// Enquanto existirem linhas no ficheiro, l para a string linha
				stringstream ss (linha);							// Cria uma stringstream ss a partir da linha lida
				getline (ss,dados,';');								// L uma string (dados) at encontrar um ';'
				if (dados == "CURSO") {								// Caso a string seja "CURSO"
					getline (ss,dados,';');							// L os dados at um ';' ficando a apontar para o cdigo do curso
					setCodigo(stoi(dados));							// inicializa os dados lidos para cdigo
					getline (ss,dados,';');							// L os prximos dados at um ';'ficando a apontar para o nome do curso
					setNome(dados);									// inicializa os dados lidos para nome
				}
			}
		}
	ficheiro.close();												// Fecha o ficheiro
}
//Destruidor
Cmenu::~Cmenu(){
}

// Mtodo para imprimir os dados de um curso no ecr
void Cmenu::imprimeCurso(){

	cout << left << setw(larguraInicial) << setfill(separador) << "";				// cria espao em branco inicial
	cout << left << setw(larguraCodigo) << setfill(separador) << getCodigo();			// imprime o Cdigo do curso
	cout << left << setw(larguraNome) << setfill(separador) << getNome();			// imprime nome do curso
	cout << left << setw(larguraFicheiro) << setfill(separador) << getNomeFicheiro() << endl;	// imprime o nome do ficheiro
}

//END namespace
}
