/*
 *  E-FolioB
 *  Menu.h
 *
 *     Created on: 17/12/2020
 *         Author: Jorge Matias
 * Student Number: 1901807
 */

#ifndef CMENU_H_
#define CMENU_H_

#include <iostream>						// Para manipulao de streams de input output
#include <string>						// Para manipulao de strings
#include <sstream>						// Para manipulao de stringstreams
#include <fstream>						// Para manipulao de ficheiros
#include <iomanip>						// Para formatao no cout

namespace std{



class Cmenu{
private:
	int codigo;							// Inteiro que ir receber o cdigo do curso
	string nome;						// string que ir receber o nome do curso
	string nomeFicheiro;				// string que ir receber o nome do Ficheiro

public:
	Cmenu();							// Construtor vazio
	Cmenu(string nomeF);				// Construtor de inicializao de dados na classe
	virtual ~Cmenu();					// Destrutor

	const char separador = ' ';  		// Definio do caracter de separao
	const int larguraInicial = 8;		// Largura inicial do output
	const int larguraCodigo = 15;		// Largura da coluna do cdigo
	const int larguraNome = 50;			// Largura da coluna do nome
	const char linha = '-';				// caracter separador para desenhar ----
	const int larguraFicheiro = 10;		// Largura da coluna Ficheiro


	//MTODOS
	void imprimeCurso();									// Mtodo para imprimir a informao de um curso

	//Mtodos de inicializao de objetos
	void setCodigo( int c ) { codigo = c; };
	void setNome ( string n ) { nome = n; };
	void setNomeFicheiro (string nf) {nomeFicheiro = nf; };

	//Mtodos de leitura de objetos
	int getCodigo() { return codigo; };
	string getNome() { return nome; };
	string getNomeFicheiro() { return nomeFicheiro; };

};

//END namespace
}
#endif /* CMENU_H_ */
